Tagged Tags:

周六多码文,后日早上一篇,后天再来一篇:

在线编制程序:

在线预览:http://github.lesschina.com/python/base/oop/3.极度相关.html

代码裤子:

 

1.异常¶

1.1 try…except¶

又到了开新课的时候了,小明同学这一次提前预习了文化,乘着老师还没来就在黑板上写下了这段Code:

In [1]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

division by zero

 

1.2 try…except…else…finally¶

小潘同学刚进来就映爱护帘了,自语道:“try...except破获万分什么人不会?就能如此屁点东西辛亏意思秀,切~
小编给你把 格式补全”

于是乘着小明上洗手间的时候,擦掉小明的Code,自个儿写了一段高大上的Code:

In [www.yabovip4.com ,2]:

# 异常捕获全格式
def test(input_str):
    try:
        eval(input_str)
    except ZeroDivisionError as ex:
        print("except:", ex)
    else:
        print("else:没有异常就奖励100块~")
    finally:
        print("finally:小明是傻子~")


def main():
    test("1/0")
    print("-" * 10)
    test("print('小明啊小明你调坑里了~')")


if __name__ == '__main__':
    main()

 

except: division by zero
finally:小明是傻子~
----------
小明啊小明你调坑里了~
else:没有异常就奖励100块~
finally:小明是傻子~

 

此时小明和师资联手进入了,同学们隐隐间都听到小明的自夸声:“老师,小编可好了,提前预习并且还写了个demo在黑板上呢~”

助教一进门望着黑板就笑了,同学们也笑成一片。小明心想,咦~难道我写错了?定眼一看黑板,气呼呼的回座位了

else能够不写,可是大家
基本上依然会写的,究竟能够领略是确实未有不当,而不是挡住了错误

1.3 两个要命管理¶

亚搏app官方网站 ,教育工小编很安详,以为那个班真风趣,大家学习空前热情,为了照拂小明,老师反问道:“有什么人知道
四个非常怎么处理?”

小明赶快的举手并把黑板上内容擦完,写下了如下代码:

In [3]:

# 多个异常捕获
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except NameError as ex:
        print(ex)
    except ZeroDivisionError as ex:
        print(ex)

if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

讲师问了小澳优声,有几个出口?

小明骄傲的说道:“两个,我写了四个拾叁分管理,当然都实践了”

同桌们又笑了,小潘作弄的说了句:“一看就驾驭二〇一八年C#没好好学,这不都一律嘛,碰到特别上面代码还实施呢?用血汗好好想想”

当大家感觉某个代码恐怕会出错时,就足以用try来运作这段代码,假诺实施出错,则继续代码不会继续实践,而是径直跳转至except语句块,执行完except后,如果有finally语句块,则执行finally语句块

小明又狼狈了。。。

1.4 多可怜简写¶

先生再度帮小明圆了个场:“已经很不轻便了,便是最终小得意的时候口误了,那小明同学你知道Python里面多可怜有个方便人民群众写法吗?”

小明赶紧拿起粉笔刷刷刷的写完,然后说道:“of course

代码裤子。In [4]:

# 多个异常捕获的简写(注意哦,是元组哦)
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except (NameError, ZeroDivisionError) as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

教员职员和工人赶紧夸了夸小明,心想,哎呦喂终于把那难缠的家伙弄回座位了。

小明走前还不忘说一句:“简写的时候注意格式哦,是 元组 不是逗号分隔”

教育工小编那堂课很自在,我们都预习了并且内容也比较轻易。

随之以咨询的措施问道:“小潘同学,你领悟这个的基类是什么啊?假设要捕获全部特别该咋做呢?”

小潘站起来讲道:“是BaseException

先生增添道:“全体的谬误类型都延续自BaseException,所以在接纳except时索要留心的是,它不止捕获该品种的荒唐,还把其子类也一块儿抓获了”

故而一般在捕获卓殊的时候 把子类相当放在前面,父类放在后边

看如下代码:

In [5]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except BaseException as ex:
        print("base:", ex)
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

base: division by zero

 

假使把父类放第三个,那么ZeroDivisionError千古也不会被实行了,其实你如若装了
代码标准提醒插件会唤醒您的

代码裤子。能够仿照效法笔者前面写的
vscode设置python3调度情形的恢宏部分

来个通用至极捕获的简写(官方不引入应用简写):

代码裤子。In [6]:

# 直接except就行了
def main():
    try:
        1 / 0
        dnt += 1
    except:
        print("屏蔽错误")


if __name__ == '__main__':
    main()

 

屏蔽错误

 

教员职员和工人继续讲到,大家来看叁个面貌,今后数不胜数在线编辑器,你在他们那一个编辑框里写下了代码也会有不行抛出的,那是怎么管理的吗?

微软有开源代码编辑器相比较受招待(VSCode的一部分):monaco-editor

提醒一下,要是实在要做在线编辑器,记得思虑一下fork炸弹,那几个实际上也是很老的事物了,技术员基本上都应该接触过了

1.5 抛出拾壹分¶

大家继续,像C#是用thorw抛出特别,那Python怎么 捕获异常后再抛出
呢?怎么自定义异常 呢?

持续往下看:

In [7]:

# 捕获异常后再丢出,eg:在线运行的用户Code
def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)  # 写个日志,回头出问题可以深究
        raise


if __name__ == '__main__':
    main()

 

division by zero

 

---------------------------------------------------------------------------
ZeroDivisionError                         Traceback (most recent call last)
<ipython-input-7-15f01346e2d8> in <module>()
      9 
     10 if __name__ == '__main__':
---> 11main()

<ipython-input-7-15f01346e2d8> in main()
      2 def main():
      3     try:
----> 41 / 0  # ZeroDivisionError: division by zero
      5     except ZeroDivisionError as ex:
      6         print(ex)  # 写个日志,回头出问题可以深究

ZeroDivisionError: division by zero

In [8]:

# 抛出自定义异常
class DntException(BaseException):
    pass


def get_age(num):
    if num <= 0:
        raise DntException("num must>0")
    else:
        print(num)


def main():
    get_age(-1)
    get_age(22)  # 程序崩了,这句话不会被执行了


if __name__ == '__main__':
    main()

 

---------------------------------------------------------------------------
DntException                              Traceback (most recent call last)
<ipython-input-8-7c9dec6ec225> in <module>()
     17 
     18 if __name__ == '__main__':
---> 19main()

<ipython-input-8-7c9dec6ec225> in main()
     12 
     13 def main():
---> 14get_age(-1)
     15     get_age(22)  # 程序崩了,这句话不会被执行了
     16 

<ipython-input-8-7c9dec6ec225> in get_age(num)
      6 def get_age(num):
      7     if num <= 0:
----> 8raise DntException("num must>0")
      9     else:
     10         print(num)

DntException: num must>0

 

十分这一块大致讲完了(logging模块前边会说)有怎样补充的能够说的^_^

 

1.6 C#异常¶

小明又举行了C#的代码转换,怎么看都觉着依旧C#概括啊,根本并非说吗,代码一贴就秒懂了。。。

In [1]:

%%script csharp
try
{
    Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}

 

Input string was not in a correct format.

In [2]:

%%script csharp
//抛出自定义异常
try
{
    throw new Exception("出错了啊");
}
catch (Exception ex)
{
    Console.WriteLine(ex.Message);
}

 

出错了啊

 

您可以自定义极度类,承接Exception就可以,对了C#个中也可能有finally的

try
{
    throw new Exception("出错了啊");
    //Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}
finally
{
    Console.WriteLine("finally");
}

现行反革命有个别索要finally的地点好多都被using(){}接管了,所以一定情景会使用

先这么了

发表评论

电子邮件地址不会被公开。 必填项已用*标注